<!DOCTYPE html><html lang="en"><head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    
    <title>Document</title>
  <style>
#webforms_send_section , #webforms_load_json_section{
  display: flex;
  justify-content: space-around;
  align-items: center;
  margin-top: 2rem;

}
#webforms_load_json_section{
flex-direction: column;
}
#webforms_send_section{
flex-direction: row;
margin-bottom: 3rem !important;
display: none;
padding: 2rem !important;
}

#webforms_send_section > input, #webforms_send_section > button, #webforms_load_json_section > button {
background-color: #00a4d7 ;
height: 2.9rem;
width: 12rem;
border-radius: 3px;
padding: 0.6rem 1rem;
text-align: center;
color: white;
outline: none;
cursor: pointer;
border: none;
text-transform: uppercase;
font-weight: 400 !important;
font-family: exo-semibold, sans-serif !important
}

#webforms_send_section > input:hover, #webforms_send_section > button:hover {
background-color: #0081a9;

}
#webforms_load_json_section > input, #webforms_load_json_section > button{
margin: 1rem;
}
#webforms_attachments_button, #webforms_cancel_button {
background-color: #ffffff !important;
border: 1px solid #00a4d7 !important;
color: #00a4d7 !important;
}
#webforms_attachments_button:hover, #webforms_cancel_button:hover {
background-color: #00a4d7 !important;
color: white !important;
}
.modal {
display: none;
position: fixed;
top: 0;
left: 0;
width: 100%;
height: 100%;
background-color: rgba(165, 165, 165, 0.7);
}
.modal-content {
position: absolute;
top: 50%;
left: 50%;
transform: translate(-50%, -50%);
text-align: center;
}

.loader {
border: 4px solid #3498db; /* Color azul */
border-top: 4px solid transparent;
border-radius: 50%;
width: 20px;
height: 20px;
animation: spin 1s linear infinite;
}

body.loading {
overflow: hidden;
}
body.loading .modal {
display: block;
}
.toast {
display: none;
position: fixed;
bottom: 20px;
left: 20px;
font-weight: bold;
background: #fdfd82;
color: rgb(51, 51, 51);
padding: 10px;
border-radius: 5px;
box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.2);
z-index: 999;
}
.toast.show {
display: block;
}
.step {
display: none;
}
.page-number {
display: flex;
justify-content: center;
font-size: 1rem;
font-weight: bold;
color: #2980b9;
}

.current-page {
margin-right: 5px;
}

.separator {
margin: 0 5px;
}

.total-pages {
margin-left: 5px;
}
@keyframes spin {
0% { transform: rotate(0deg); }
100% { transform: rotate(360deg); }
}
@media (max-width: 720px) {
#webforms_send_section  {
  flex-direction: column;
}
#webforms_send_section > button, #webforms_send_section > input{
  width: 100%;
  margin-bottom: 0.8rem !important;
}
}</style></head>
  <body>
    <section id="webforms_load_json_section" style="display: none;">
        <input type="file" accept=".json" id="webforms_json_input">
      <button id="webforms_load_json_button">Cargar JSON</button>
    </section>
    <div id="webforms_wizard">
        <form id="webforms_main_form"></form>
    </div>
    
    <hr>
    <section id="webforms_send_section">
      <input type="submit" id="webforms_send" value="Aceptar" form="webforms_main_form">
    </section>
    <div id="webforms_page_number" class="page-number"></div>
    <div class="toast" id="webforms_toast">
      <div class="toast-content">
      </div>
  </div>
    <div class="modal">
      <div class="modal-content">
        <div class="loader"></div>
      </div>
    </div>

    
   
  <script>class EventEmitter {
    constructor() {
        this.events = {};
    }
    on(eventName, callback) {
        if (!this.events[eventName]) {
            this.events[eventName] = [];
        }
        this.events[eventName].push(callback);
    }
    emit(eventName, ...args) {
        const callbacks = this.events[eventName];
        if (callbacks) {
            callbacks.forEach(callback => {
                callback(...args);
            });
        }
    }
}


class Wizard {
    constructor(form) {
        this.steps = document.querySelectorAll(".step");
        this.currentStep = 0;
        this.form = form;
        this.showStep(this.currentStep);
        this.printPaginator();
        document
            .querySelector(".next")
            .addEventListener("click", this.onNextClick.bind(this));
        document
            .querySelector(".prev")
            .addEventListener("click", this.onPrevClick.bind(this));
        form.addEventListener("submit", (e) => {
            e.preventDefault();
            if (form.checkValidity() && this.customValidations(form, null, null)) {
                Wizard.emitter.emit('validForm');
            }
        });
        form.addEventListener('input', (event) => {
            const target = event.target;
            if (target.tagName === 'INPUT') {
                this.customValidations(form, null, target);
            }
        });
    }
    onNextClick() {
        const currentPage = document.getElementById("webforms_current_page");
        if (this.currentStep < this.steps.length - 1 &&
            this.form.reportValidity() && this.customValidations(this.form, parseInt(currentPage.innerText), null)) {
            this.currentStep++;
            if (currentPage) {
                currentPage.innerHTML = (this.currentStep + 1).toString();
            }
            this.showStep(this.currentStep);
        }
    }
    onPrevClick() {
        const currentPage = document.getElementById("webforms_current_page");
        if (this.currentStep > 0) {
            this.currentStep--;
            if (currentPage) {
                currentPage.innerHTML = (this.currentStep + 1).toString();
            }
            this.showStep(this.currentStep);
        }
    }
    showStep(step) {
        this.steps.forEach((s, index) => {
            const isCurrentStep = index === step;
            s.style.display = isCurrentStep ? "block" : "none";
            window.scrollTo({
                top: 0,
            });
            this.setInputDisabled(s, !isCurrentStep);
        });
    }
    setInputDisabled(step, disabled) {
        const inputs = step.querySelectorAll("input[required]");
        inputs.forEach((input) => {
            input.disabled = disabled;
        });
    }
    printPaginator() {
        const container = document.getElementById("webforms_page_number");
        const currentPage = document.createElement("span");
        const separator = document.createElement("span");
        const totalPages = document.createElement("span");
        currentPage.setAttribute("class", "current-page");
        currentPage.setAttribute("id", "webforms_current_page");
        separator.setAttribute("class", "separator");
        totalPages.setAttribute("class", "total-pages");
        currentPage.innerHTML = (this.currentStep + 1).toString();
        separator.innerHTML = "/";
        totalPages.innerHTML = this.steps.length.toString();
        if (container) {
            container.appendChild(currentPage);
            container.appendChild(separator);
            container.appendChild(totalPages);
        }
    }
    isLastPage() {
        return this.currentStep === this.steps.length - 1;
    }
    isFirstPage() {
        return this.currentStep === 0;
    }
    stepIsValid() {
        return this.form.reportValidity();
    }
    getFormSteps() {
        return this.steps.length;
    }
    customValidations(form, page, selectedInput) {
        let inputs;
        // Obtener los inputs según la página o el formulario completo
        if (page !== null) {
            inputs = form.children[page - 1].querySelectorAll("input");
        }
        else {
            inputs = form.querySelectorAll('input');
        }
        let isValid = true; // Variable de control para la validación
        // Función para validar un input específico
        const validateInput = (input) => {
            if (input.dataset.rules === "NIFNIE") {
                const inputIsValid = validateNIFNIE(input.value);
                if (!inputIsValid) {
                    input.style.borderColor = "#EF424D";
                    // Hacer scroll hacia el input inválido
                    input.scrollIntoView({ behavior: "smooth", block: "center" });
                    isValid = false;
                }
                else {
                    input.style.borderColor = "#00cd00";
                }
            }
        };
        // Validar formulario completo o un input específico
        if (selectedInput === null) {
            inputs.forEach(input => {
                validateInput(input);
            });
        }
        else {
            validateInput(selectedInput);
        }
        return isValid;
    }
}
Wizard.emitter = new EventEmitter();
// Define las interfaces

class WebForms {
    constructor() {
        this.globalJson = {};
    }
    init(container = null, json = null, callback) {
        this.callback = callback;
        this.container = container;
        let jsonData = null;
        if (this.container) {
            this.createDivContainers();
        }
        this.toJson = document.getElementById("webforms_send");
        this.formContainer = document.getElementById("webforms_main_form");
        document.body.classList.add("loading");
        // Si viene el campo document informado creamos la estructura conveniente
        if (json.document && json.document.form) {
            jsonData = json.document.form;
        }
        else {
            jsonData = json;
        }
        this.loadJsonData(jsonData);
        if (json.document && json.document.formValues) {
            this.setFormValues(json.document.formValues);
        }
        Wizard.emitter.on("validForm", () => {
            this.changeStylesBeforePDF();
            this.generateJSONFromInputs();
        });
    }
    // Función para renderizar el formulario a partir de los datos JSON
    // Se ha decidido usar un sistema de elementos personalizados, y no un subtype directamente en el json.
    // Se le añade a nivel de codigo ese subtype para hacer la lógica.
    renderForm(page, form) {
        page.items.forEach((item) => {
            switch (item.type) {
                //image
                case "image":
                    if (item.src) {
                        this.renderImageElement(item, form);
                    }
                    break;
                //text
                case "headerText":
                    item.subType = "h1";
                    this.renderTextElement(item, form);
                    break;
                case "paragraphText":
                    item.subType = "p";
                    this.renderTextElement(item, form);
                    break;
                case "continuousText":
                    item.subType = "span";
                    this.renderTextElement(item, form);
                    break;
                //inputs
                case "textField":
                    item.subType = "text";
                    this.renderTextInput(item, form);
                    break;
                case "numberField":
                    item.subType = "number";
                    this.renderTextInput(item, form);
                    break;
                case "radioButton":
                    item.subType = "radio";
                    if (item.options) {
                        this.renderRadioInput(item, form);
                    }
                    break;
                case "dateField":
                    item.subType = "date";
                    this.renderTextInput(item, form);
                    break;
                case "emailField":
                    item.subType = "email";
                    this.renderTextInput(item, form);
                    break;
                //table
                case "table":
                    item.subType = "table";
                    this.renderTable(item, form);
                    break;
                //dividers
                case "pageBreak":
                    item.subType = "div";
                    this.renderDivider(item, form);
                    break;
                case "barBreak":
                    item.subType = "hr";
                    this.renderDivider(item, form);
                    break;
                case "lineBreak":
                    item.subType = "br";
                    this.renderDivider(item, form);
                    break;
                default:
                    break;
            }
        });
    }
    setGeneralStyles(styles) {
        for (const key in styles) {
            document.getElementById("webforms_wizard").style[key] = styles[key];
        }
    }
    // Función para renderizar elementos de entrada tipo radio
    renderRadioInput(item, form) {
        const legend = document.createElement("legend");
        legend.setAttribute("id", item.id + "_legend");
        form.appendChild(legend);
        legend.textContent = item.label;
        this.addCss(item, legend);
        if (item.visible === false) {
            legend.style.display = "none";
        }
        if (item.options) {
            item.options.forEach((option) => {
                option.customId = Math.floor(Math.random() * 90000) + 10000;
                const input = this.createInputElement(item, option);
                const label = this.createLabelElement(item, option);
                //if position is vertical, options are appended into a div
                if (item.verticalOptions) {
                    const container = document.createElement("div");
                    container.appendChild(input);
                    container.appendChild(label);
                    form.appendChild(container);
                }
                else {
                    form.appendChild(input);
                    form.appendChild(label);
                }
            });
        }
    }
    // Función para renderizar elementos de entrada de texto
    renderTextInput(item, form) {
        const input = this.createInputElement(item);
        const label = this.createLabelElement(item);
        form.appendChild(label);
        form.appendChild(input);
    }
    // Función para crear elementos de entrada de texto o radio
    createInputElement(item, value) {
        const input = document.createElement("input");
        this.setInputAttributes(item, value, input);
        this.inputValueChanged(item, input);
        this.addCss(item, input);
        return input;
    }
    renderDivider(item, form) {
        const divider = this.createDividerElement(item.subType);
        if (divider) {
            form.appendChild(divider);
        }
    }
    createDividerElement(subType) {
        let divider;
        divider = document.createElement(subType);
        if (subType === "div") {
            divider.style.pageBreakBefore = "always";
        }
        return divider;
    }
    // Función para crear etiquetas de elementos de entrada
    createLabelElement(item, value) {
        const label = document.createElement("label");
        if (item.subType === "radio" && item.options) {
            label.setAttribute("for", `${item.id}_${value.customId}`);
        }
        else {
            label.setAttribute("for", item.id);
        }
        if (value) {
            label.textContent = value.value;
        }
        else {
            label.textContent = item.label;
        }
        if (item.visible === false) {
            label.style.display = "none";
        }
        this.addCss(item, label);
        return label;
    }
    // Función para renderizar elementos de texto
    renderTextElement(item, form) {
        const text = document.createElement(item.subType);
        text.textContent = item.label;
        if (item.id) {
            text.setAttribute("id", item.id);
        }
        //[modificada para typescript]
        if (item.css) {
            Object.entries(item.css).forEach(([key, value]) => {
                text.style.setProperty(key, value);
            });
        }
        if (item.visible === false) {
            text.style.display = "none";
        }
        this.addCss(item, text);
        form.appendChild(text);
    }
    // Función para renderizar elementos de imagen
    renderImageElement(item, form) {
        const image = document.createElement("img");
        if (item.src) {
            // Verificar si item.src tiene un valor
            image.src = item.src;
        }
        form.appendChild(image);
        if (item.visible === false) {
            image.style.display = "none";
        }
        this.addCss(item, image);
    }
    //función para renderizar tablas
    renderTable(item, form) {
        const table = this.createTableElement(item);
        form.appendChild(table);
    }
    createTableElement(item) {
        const table = document.createElement("table");
        this.createTableHead(item, table);
        this.createTableData(item, table);
        this.addCss(item, table);
        return table;
    }
    createTableHead(item, table) {
        const thRows = item.cells.th;
        const thRow = table.insertRow();
        //crea filas de cabecera
        thRows.forEach((element) => {
            const th = document.createElement("th"); // create th element
            th.innerHTML = element;
            thRow.appendChild(th);
            //addCss(item, cell);
        });
    }
    createTableData(item, table) {
        const trRows = item.cells.tr;
        //crea filas de datos
        trRows.forEach((element) => {
            const row = table.insertRow();
            for (const key in element) {
                element[key].forEach((element) => {
                    const cell = row.insertCell();
                    cell.innerHTML = element;
                    //addCss(item, cell);
                });
            }
        });
    }
    // Función para añadir CSS
    addCss(item, type) {
        if (item.css) {
            for (const cssKey in item.css) {
                const normalizedCssKey = this.normalizeCssProperty(cssKey);
                const cssValue = item.css[cssKey];
                type.style.setProperty(this.toDashCase(normalizedCssKey), cssValue);
            }
        }
    }
    toDashCase(propertyName) {
        return propertyName.replace(/[A-Z]/g, function (match) {
            return "-" + match.toLowerCase();
        });
    }
    normalizeCssProperty(propertyName) {
        return propertyName.replace(/-([a-z])/g, function (_, letter) {
            return letter.toUpperCase();
        });
    }
    //Función para setear todas las propiedades de los inputs
    setInputAttributes(item, value, input) {
        input.name = item.id;
        input.type = item.subType;
        if (item.subType === "radio" && item.options) {
            input.id = `${item.id}_${value.customId}`;
        }
        else {
            input.id = item.id;
        }
        if (item.value) {
            input.setAttribute("value", item.value);
            input.setAttribute("size", input.value.length + "px");
        }
        else {
            input.setAttribute("size", 10 + "px");
        }
        if (value) {
            input.value = value.value;
        }
        if (item.subType === "radio" && value.checked) {
            input.setAttribute("checked", "checked");
        }
        if (item.editable === false) {
            input.disabled = true;
        }
        if (item.visible === false) {
            input.style.display = "none";
        }
        if (item.required) {
            input.required = true;
        }
        if (item.pattern) {
            input.setAttribute("pattern", item.pattern);
        }
        if (item.rules) {
            input.dataset.rules = "NIFNIE";
        }
        if (item.today) {
            input.setAttribute("value", this.formatDateISOToYYYYMMDD());
        }
    }
    //TODO: refactor
    inputValueChanged(item, input) {
        input.addEventListener("input", (event) => {
            if (input.type === "radio") {
                const radioButtons = document.querySelectorAll(`input[type="radio"][name=${input.name}]`);
                radioButtons.forEach((radioButton) => {
                    radioButton.removeAttribute("checked");
                });
                input.setAttribute("checked", "checked");
                if (item.actions) {
                    item.actions.forEach((actions) => {
                        const element = document.getElementById(actions.relatedId);
                        if (element != null) {
                            this.textActions(actions, input);
                        }
                        else {
                            this.radioButtonActions(actions, input);
                        }
                    });
                }
            }
            else {
                const newVal = event.target.value;
                this.setInputValueToElement(input.id, newVal);
                input.setAttribute("value", newVal);
                if (input.value.length > input.size && input.value.length > 10) {
                    input.setAttribute("size", input.value.length + "px");
                }
                else {
                    if (input.value.length === 0) {
                        input.setAttribute("size", 10 + "px");
                    }
                    else {
                        if (input.value.length >= 10) {
                            input.setAttribute("size", input.value.length + "px");
                        }
                    }
                }
            }
        });
    }
    /** Busca si hay elementos asociados a un input para reemplazar sus valores */
    setInputValueToElement(inputId, newValue) {
        // Buscar en todo el json si hay algun elemento con el atributo getValueOf y si tiene asociado el id del inputId
        this.globalJson.pages.forEach((page) => {
            page.items.forEach((element) => {
                if (element.getValuesOf && element.getValuesOf === inputId) {
                    const domElement = document.getElementById(element.id); // En caso de que si, cambiarle el valor por newValue
                    if (domElement instanceof HTMLInputElement) {
                        // Si es de tipo input
                        domElement.value = newValue;
                    }
                    else {
                        domElement.innerHTML = newValue;
                    }
                }
            });
        });
    }
    textActions(actions, input) {
        const label = document.querySelector(`label[for*=${actions.relatedId}]`);
        const element = document.getElementById(actions.relatedId);
        if (actions.value === input.value) {
            if (actions.visible) {
                element.style.display = "block";
                if (label) {
                    label.style.display = "block";
                }
                if (actions.required) {
                    element.setAttribute("required", actions.required);
                }
            }
            else {
                element.style.display = "none";
                if (label) {
                    label.style.display = "none";
                }
                element.required = false;
            }
        }
    }
    radioButtonActions(actions, input) {
        const elements = document.getElementsByName(actions.relatedId);
        const labels = document.querySelectorAll(`label[for*=${actions.relatedId}]`);
        const legend = document.getElementById(`${actions.relatedId}_legend`);
        if (actions.value === input.value) {
            if (actions.visible) {
                labels.forEach((label) => {
                    label.style.display = "initial";
                });
                for (let index = 0; index < elements.length; index++) {
                    const element = elements[index];
                    element.style.display = "initial";
                    if (actions.required) {
                        element.setAttribute("required", actions.required);
                    }
                }
                if (legend) {
                    legend.style.display = "block";
                }
            }
            else {
                labels.forEach((label) => {
                    label.style.display = "initial";
                });
                for (let index = 0; index < elements.length; index++) {
                    const element = elements[index];
                    element.style.display = "none";
                    labels.forEach((label) => {
                        label.style.display = "none";
                    });
                    if (legend) {
                        legend.style.display = "none";
                    }
                    element.required = false;
                }
            }
        }
        else {
            //remove radios checked if hide actions again
            const radioButtons = document.querySelectorAll(`input[type="radio"][name=${actions.relatedId}]`);
            radioButtons.forEach((radioButton) => {
                radioButton.checked = false;
            });
        }
    }
    changeStylesBeforePDF() {
        const dateInputs = document.querySelectorAll('input[type="date"]');
        const stepElements = document.querySelectorAll("div.step");
        const webforms_wizard = document.getElementById("webforms_wizard");
        // Quitar el borde de los inputs
        webforms_wizard
            .querySelectorAll("input")
            .forEach((input) => {
            input.style.border = "none";
            input.style.backgroundColor = "white";
        });
        // Itera a través de los elementos y establece el atributo "readonly" en cada uno para quitar el icono del picker
        dateInputs.forEach(function (input) {
            input.setAttribute("readonly", "true");
        });
        stepElements.forEach(function (step) {
            step.style.display = "block";
        });
    }
    startWizard() {
        const sendJsonSection = document.getElementById("webforms_send_section");
        const nextButton = document.createElement("button");
        const prevButton = document.createElement("button");
        nextButton.setAttribute("class", "next");
        prevButton.setAttribute("class", "prev");
        nextButton.innerHTML = "Siguiente";
        prevButton.innerHTML = "Atrás";
        prevButton.style.display = "none";
        nextButton.style.display = "none";
        this.toJson.style.display = "none";
        sendJsonSection.insertBefore(nextButton, sendJsonSection.lastChild);
        sendJsonSection.insertBefore(prevButton, sendJsonSection.firstChild);
        //TODO: CREAR CLASE INSTANCIA WIZARD
        const wizard = new Wizard(this.formContainer);
        if (wizard.getFormSteps() > 1) {
            nextButton.style.display = "block";
        }
        if (wizard.isLastPage()) {
            this.toJson.style.display = "block";
        }
        document.querySelector(".next").addEventListener("click", () => {
            prevButton.style.display = wizard.isFirstPage() ? "none" : "block";
            nextButton.style.display = wizard.isLastPage() ? "none" : "block";
            if (wizard.isLastPage()) {
                this.toJson.style.display = "block";
            }
        });
        document.querySelector(".prev").addEventListener("click", () => {
            if (wizard.stepIsValid()) {
                prevButton.style.display = wizard.isFirstPage() ? "none" : "block";
                nextButton.style.display = "block";
            }
            if (!wizard.isLastPage()) {
                this.toJson.style.display = "none";
            }
        });
    }
    // Función para generar un nuevo JSON a partir de los valores de los inputs
    generateJSONFromInputs() {
        const inputs = document.querySelectorAll("#webforms_main_form input");
        const clonedObject = this.globalJson;
        const outputJSON = [];
        clonedObject.pages.forEach((page) => {
            page.items.forEach((item) => {
                if (item.id) {
                    const newItem = { id: item.id, value: null };
                    inputs.forEach((input) => {
                        if (item.id === input.name && input.type === "radio") {
                            newItem.value = input.checked
                                ? input.value
                                : !this.isRadioGroupChecked(input.name)
                                    ? ""
                                    : newItem.value;
                        }
                        if (item.id === input.id &&
                            ["date", "email", "text", "tel", "password", "number"].includes(input.type)) {
                            newItem.value = this.parseInputValue(input);
                        }
                    });
                    if (newItem.value !== null) {
                        outputJSON.push(newItem);
                    }
                }
            });
        });
        this.callback(JSON.stringify({
            type: "output",
            json: outputJSON,
            html: this.outerHTMLstructure(),
        }));
    }
    isRadioGroupChecked(groupName) {
        const radios = document.querySelectorAll(`input[type="radio"][name="${groupName}"]`);
        return Array.from(radios).some((radio) => radio.checked);
    }
    parseInputValue(input) {
        switch (input.type) {
            case "date":
                return this.formatDateToISO(input.value);
            case "number":
                return parseFloat(input.value);
            default:
                return input.value;
        }
    }
    outerHTMLstructure() {
        const formHTML = document.getElementById("webforms_wizard").outerHTML;
        const wrapperHTML = `
          <!DOCTYPE html>
          <html lang="es">
            <head>
              <meta charset="UTF-8">
            </head>
            <body>
              ${formHTML}
            </body>
          </html>
    `;
        return wrapperHTML;
    }
    loadJsonData(jsonData) {
        const sendJsonSection = document.getElementById("webforms_send_section");
        this.setGeneralStyles(jsonData.generalStyles);
        this.globalJson = jsonData;
        try {
            jsonData.pages.forEach((element) => {
                const stepContainer = document.createElement("div");
                sendJsonSection.style.display = "flex";
                stepContainer.setAttribute("class", "step");
                this.formContainer.appendChild(stepContainer);
                this.renderForm(element, stepContainer);
            });
            this.startWizard();
        }
        catch (error) {
            this.callback(JSON.stringify({
                type: "error",
                value: "Es posible que falten elementos en el archivo JSON",
            }));
        }
        finally {
            document.body.classList.remove("loading");
        }
    }
    //dynamics divs,elements only for psc
    createDivContainers() {
        // Crear elementos HTML
        const webforms_wizard = document.createElement("div");
        const webforms_main_form = document.createElement("form");
        const webforms_send_section = document.createElement("section");
        const webforms_send_button = document.createElement("input");
        const webforms_cancel_button = document.createElement("button");
        const webforms_attachments_button = document.createElement("button");
        // Configurar atributos y contenido de los elementos
        webforms_wizard.setAttribute("id", "webforms_wizard");
        webforms_main_form.setAttribute("id", "webforms_main_form");
        webforms_send_section.setAttribute("id", "webforms_send_section");
        webforms_cancel_button.setAttribute("id", "webforms_cancel_button");
        webforms_attachments_button.setAttribute("id", "webforms_attachments_button");
        webforms_send_button.setAttribute("id", "webforms_send");
        webforms_send_button.setAttribute("type", "submit");
        webforms_send_button.setAttribute("value", "Aceptar");
        webforms_cancel_button.innerText = "Rechazar";
        webforms_attachments_button.innerText = "Adjuntos";
        webforms_attachments_button.style.display = "none";
        webforms_send_button.setAttribute("form", "webforms_main_form");
        // Agregar clases CSS
        webforms_send_section.classList.add("container-md");
        webforms_wizard.classList.add("container-md");
        webforms_cancel_button.classList.add("button--cancel");
        // Adjuntar elementos al DOM
        this.container.append(webforms_wizard);
        webforms_wizard.append(webforms_main_form);
        this.container.append(webforms_send_section);
        webforms_send_section.append(webforms_cancel_button);
        webforms_send_section.append(webforms_attachments_button);
        webforms_send_section.append(webforms_send_button);
        // Agregar evento de clic al botón de cancelar
        webforms_cancel_button.addEventListener("click", () => {
            // Acceder al callback utilizando el contexto correcto
            this.callback(JSON.stringify({ type: "cancel" }));
        });
    }
    /** Muestra el elemento*/
    showButton(button) {
        if (button === "attachment") {
            const webforms_attachments_button = document.getElementById("webforms_attachments_button");
            if (webforms_attachments_button) {
                webforms_attachments_button.style.display = "inline-block";
                webforms_attachments_button.addEventListener("click", () => {
                    // Acceder al callback utilizando el contexto correcto
                    this.callback(JSON.stringify({ type: "attachments" }));
                });
            }
        }
    }
    /** Habilita el elemento*/
    enable(button) {
        if (button === "accept") {
            const webforms_accept_button = document.getElementById("webforms_send");
            if (webforms_accept_button) {
                webforms_accept_button.classList.remove("button-invalid");
            }
        }
    }
    /** Deshabilita el elemento*/
    disable(button) {
        if (button === "accept") {
            const webforms_accept_button = document.getElementById("webforms_send");
            if (webforms_accept_button) {
                webforms_accept_button.classList.add("button-invalid");
            }
        }
    }
    /** Cierra webforms */
    close() {
        const webforms_wizard = document.getElementById("webforms_wizard");
        const webforms_send_section = document.getElementById("webforms_send_section");
        if (webforms_wizard) {
            webforms_wizard.remove();
        }
        if (webforms_send_section) {
            webforms_send_section.remove();
        }
    }
    /** Setear los formValues */
    setFormValues(formValues) {
        this.globalJson.pages.forEach((page) => {
            page.items.forEach((item) => {
                const matchingObject = formValues.find((obj) => obj.id === item.id);
                if (matchingObject) {
                    const element = document.getElementById(item.id);
                    if (element instanceof HTMLInputElement) {
                        if (element.type === "date") {
                            element.setAttribute("value", this.formatDateISOToYYYYMMDD(matchingObject.value));
                        }
                        else {
                            // Si no es de tipo date, asignar el valor del objeto
                            element.value = matchingObject.value;
                        }
                    }
                    else {
                        element.innerHTML = matchingObject.value;
                    }
                }
            });
        });
    }
    /** Formatea las fechas */
    formatDateISOToYYYYMMDD(ISOdate) {
        // Si no se proporciona ISOdate, usar la fecha actual
        if (!ISOdate) {
            ISOdate = new Date().toISOString();
        }
        // Convertir la fecha ISO a objeto Date
        const date = new Date(ISOdate);
        // Obtener año, mes y día
        const curr_date = ("0" + date.getDate()).slice(-2); // Añadir cero delante y obtener los dos últimos dígitos
        const curr_month = ("0" + (date.getMonth() + 1)).slice(-2); // Añadir cero delante y obtener los dos últimos dígitos
        const curr_year = date.getFullYear();
        // Formatear la fecha en el formato deseado
        const formatDate = `${curr_year}-${curr_month}-${curr_date}`;
        return formatDate;
    }
    formatDateToISO(dateString) {
        if (!dateString) {
            throw new Error("The date cannot be empty");
        }
        // Verificar si la fecha sigue el formato (YYYY-MM-DD)
        const match = dateString.match(/^(\d{4})-(\d{2})-(\d{2})$/);
        if (!match) {
            throw new Error("Invalid date format. Expected format is YYYY-MM-DD");
        }
        const year = parseInt(match[1], 10);
        const month = parseInt(match[2], 10);
        const day = parseInt(match[3], 10);
        const date = new Date(year, month - 1, day);
        const isoDate = date.toISOString().split("T")[0] + "T00:00:00.000Z";
        return isoDate;
    }
}
/** Validación de NIF/NIE */
function validateNIFNIE(value) {
    if (value.trim() === '')
        return false;
    const validChars = 'TRWAGMYFPDXBNJZSQVHLCKET';
    const nifRexp = /^[0-9]{8}[TRWAGMYFPDXBNJZSQVHLCKET]$/i;
    const nieRexp = /^[XYZ][0-9]{7}[TRWAGMYFPDXBNJZSQVHLCKET]$/i;
    let str = value.toString().toUpperCase();
    if (!nifRexp.test(str) && !nieRexp.test(str))
        return false;
    const nie = str
        .replace(/^[X]/, '0')
        .replace(/^[Y]/, '1')
        .replace(/^[Z]/, '2');
    const letter = str.substr(-1);
    const charIndex = parseInt(nie.substr(0, 8)) % 23;
    if (validChars.charAt(charIndex) === letter)
        return true;
    return false;
}

window.webForms = new WebForms();</script>

</body></html>
